#include <u.h>
#include <libdwarf.h>
#include <dwarf.h>
#include "dat.h"

static struct {
	int	form;
	char	*name;
} formtab[] = {
	{ DW_FORM_addr,		"addr" },
	{ DW_FORM_block2,	"block2" },
	{ DW_FORM_block4,	"block4" },
	{ DW_FORM_data2,	"data2" },
	{ DW_FORM_data4,	"data4" },
	{ DW_FORM_data8,	"data8" },
	{ DW_FORM_string,	"string" },
	{ DW_FORM_block,	"block" },
	{ DW_FORM_block1,	"block1" },
	{ DW_FORM_data1,	"data1" },
	{ DW_FORM_flag,		"flag" },
	{ DW_FORM_sdata,	"sdata" },
	{ DW_FORM_strp,		"strp" },
	{ DW_FORM_udata,	"udata" },
	{ DW_FORM_ref_addr,	"ref_addr" },
	{ DW_FORM_ref1,		"ref1" },
	{ DW_FORM_ref2,		"ref2" },
	{ DW_FORM_ref4,		"ref4" },
	{ DW_FORM_ref8,		"ref8" },
	{ DW_FORM_ref_udata,	"ref_udata" },
	{ DW_FORM_indirect,	"indirect" },
	{ -1, nil }
};

const char*
dwarfformname(int form)
{
	int i;


	for(i=0; formtab[i].form != -1; i++)
		if(formtab[i].form == form)
			return formtab[i].name;
	return nil;
}
