BEGIN {
	printf("#include <u.h>\n");
	printf("#include <stdio.h>\n");
	printf("#include <libdwarf.h>\n");
	printf("#include <dwarf.h>\n");
	printf("#include \"dat.h\"\n");
	printf("\n");

	gen("signed", "s", 8, 64);
	gen("signed", "s", 4, 32);
	gen("signed", "s", 2, 16);
	gen("signed", "s", 1, 8);

	gen("unsigned", "u", 8, 64);
	gen("unsigned", "u", 4, 32);
	gen("unsigned", "u", 2, 16);
	gen("unsigned", "u", 1, 8);

	exit(0);
}

function gen(sign, prefix, bytes, bits)
{
	printf("%s%sint\n", prefix, bits);
	printf("dwarfget%s%s(uchar *buf, uchar *ebuf)\n", sign, bits);
	printf("{\n");
	printf("\t%s%sint x;\n", prefix, bits);
	printf("\n");
	printf("\tif(ebuf-buf < %s){\n", bytes);
	printf("\t\tfprintf(stderr, ");
	printf("\"buggered %s %s-bit value\\n\");\n", sign, bits);
	printf("\t\treturn 0;\n");
	printf("\t}\n");
	printf("\tx = *((%s%sint*)buf);\n", prefix, bits);
	printf("\treturn x;\n");
	printf("}\n");
	printf("\n");
}
