#include <u.h>
#include <stdio.h>
#include <libdwarf.h>
#include <dwarf.h>
#include "dat.h"

uintptr
dwarfgetaddress(DwarfCompileUnit *cu, uchar *buf, uchar *ebuf, int *sz)
{
	uintptr addr;

	addr = ~0;
	switch(cu->addrsz){
	case 2:
		addr = dwarfgetunsigned16(buf, ebuf);
		*sz = 2;
		break;

	case 4:
		addr = dwarfgetunsigned32(buf, ebuf);
		*sz = 4;
		break;

	case 8:
		addr = dwarfgetunsigned64(buf, ebuf);
		*sz = 8;
		break;

	default:
		fprintf(stderr, "bogus address size %d\n", cu->addrsz);
		break;
	}
	return addr;
}

Dwarf_Unsigned
dwarfgetunsignedleb128(uchar *buf, uchar *ebuf, int *sz)
{
	ulong lebsz;
	Dwarf_Unsigned rv;

	USED(ebuf);

	lebsz = 0;
	rv = dwarfdecodeuleb128(buf, &lebsz);
	*sz = lebsz;
	return rv;
}

Dwarf_Signed
dwarfgetsignedleb128(uchar *buf, uchar *ebuf, int *sz)
{
	ulong lebsz;
	Dwarf_Signed rv;

	USED(ebuf);

	lebsz = 0;
	rv = dwarfdecodesleb128(buf, &lebsz);
	*sz = lebsz;
	return rv;
}
